/**
 * \file gre/dlgdatatip.h
 * \brief GRE::DLG_DATATIPSETTINGS
 *
 * \if NODOC
 * $Id: dlgdatatip.h_v 1.5 2013/10/01 16:28:18 mju Exp $
 *
 * $Log: dlgdatatip.h_v $
 * Revision 1.5  2013/10/01 16:28:18  mju
 * Remove general form.
 *
 * Revision 1.4  2013/09/27 15:38:55  mju
 * Use datatipgeneral::form, move to gre::ui namespace.
 *
 * Revision 1.3  2008/08/28 13:17:46  mju
 * \endif
**/

#ifndef	INC_GRE_DLGDATATIPSETTINGS
#define	INC_GRE_DLGDATATIPSETTINGS

#ifndef	INC_GRE_BASE_H
#include <gre/base.h>
#endif

#ifndef	INC_GRE_UIDATATIP_H
#include <gre/uidatatip.h>
#endif

#ifndef	INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif

#ifndef	INC_MGUI_FORMTABBED_H
#include <mgui/formtabbed.h>
#endif

namespace GRE {
namespace UI {

//===================================================================================================================

//! Dialog to specify DataTip settings for layer or general only.
class DLG_DATATIPSETTINGS : public MGUI::DLGSHELL {
	public:

		explicit DLG_DATATIPSETTINGS (
			GRE::LAYER *layer = 0
			);

		~DLG_DATATIPSETTINGS ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		LAYER *m_layer;
		MGUI::FORM_TABBED m_FormTabbed;
		DATATIPPARMS::FORM *m_FormLayerComponents;

		virtual ERRVALUE v_CreateContent ();
		virtual void v_OnOK ();

		DLG_DATATIPSETTINGS (const DLG_DATATIPSETTINGS&);
		DLG_DATATIPSETTINGS& operator= (const DLG_DATATIPSETTINGS&);
		#endif	// GENERATING_DOXYGEN_OUTPUT
	};

//===================================================================================================================

}	// End namespace UI
}	// End namespace GRE

#endif	// INC_GRE_DLGDATATIPSETTINGS
