/**
 * \file gre/folder.h
 * \brief GRE::FOLDER class definition
 *
 * \if NODOC
 * $Id4
 *
 * $Log: folder.h_v $
 * Revision 1.2  2016/01/15 21:21:44  bcolombe
 * Remove qualification on method
 *
 * Revision 1.1  2013/02/15 21:30:56  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_FOLDER_H
#define	INC_GRE_FOLDER_H

#ifndef	INC_GRE_CONTAINER_H
	#include <gre/container.h>
#endif

namespace GRE {

//=====================================================================================================================

//! Folder container class to manage layers and folders.
class FOLDER : public CONTAINER {
	public:

		//! Construct in GROUP.
		FOLDER (
			GROUP *pGroup,
			LISTPOS listpos = LISTPOS_Last,
			OBJECT *pRefObject = 0
			);

		//! Construct in FOLDER.
		FOLDER (
			FOLDER *pFolder,
			LISTPOS listpos = LISTPOS_Last,
			OBJECT *pRefObject = 0
			);

		//! Destructor.
		virtual ~FOLDER ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		// OBJECT overrides.
		virtual MICONSTRUCT* v_GetIcon () const;
		virtual const char* v_GetTypeName () const;
		#endif
	};

//=====================================================================================================================

}	// End namespace GRE

#endif	// INC_GRE_FOLDER_H
