/**
 * \file gre/uidatatipgeneral.h
 * \brief GRE::DATATIPGENERAL::FORM definition
 *
 * \if NODOC
 * $Id: uidatatipgeneral.h_v 1.1 2013/10/01 16:28:37 mju Exp $
 *
 * $Log: uidatatipgeneral.h_v $
 * Revision 1.1  2013/10/01 16:28:37  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_UIDATATIPGENERAL_H
#define	INC_GRE_UIDATATIPGENERAL_H

#ifndef	INC_GRE_DATATIPGENERAL_H
#include <gre/datatipgeneral.h>
#endif

#ifndef	INC_MGUI_FORM_H
#include <mgui/form.h>
#endif


namespace GRE {

//===================================================================================================================

//! Form for editing DATATIPGENERAL.
class DATATIPGENERAL::FORM : public MGUI::FORM_COMPOSITE {
	public:

		//! Constructor.
		FORM ();

		//! Destructor.
		virtual ~FORM ();

		//! Create the form.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane		//!< Parent pane
			);

		//! Set delegate to call when values changed.
		void SetDelegateOnChangeValues (
			DELEGATE_VOID_NOPARMS delegate
			);

		//! Update shared values from form.
		void UpdateShared ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//===================================================================================================================

}	// End namespace GRE

#endif	// INC_GRE_UIDATATIPGENERAL_H
