/** 
 * \file gre/uiformplaces.h 
 * \brief Definitions for GRE::UI::FORM_PLACES class.
 *
 * \if NODOC
 * $Id: uiformplaces.h_v 1.17 2013/01/31 22:26:15 mju Exp $
 *
 * $Log: uiformplaces.h_v $
 * Revision 1.17  2013/01/31 22:26:15  mju
 * Make private stuff local to implementation module.
 *
 * Revision 1.11  2011/07/11 19:55:43  bcolombe
 * Moved zoom scale/level to separate tool
 *
 * Revision 1.1  2011/03/01 22:45:28  bcolombe
 * Initial revision
 * \endif
**/

#ifndef	INC_GRE_UIFORMPLACES_H
#define	INC_GRE_UIFORMPLACES_H

#ifndef	INC_MGUI_FORM_H
#include <mgui/form.h>
#endif


#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations.
namespace GRE {
	class VIEW;
	}
#endif


namespace GRE {
namespace UI {

//=====================================================================================================================

//! Form for "places" panel associated with GRE::VIEW.
class FORM_PLACES : public MGUI::FORM_COMPOSITE {
	public:

		//! Constructor.
		FORM_PLACES ();

		//! Destructor.
		virtual ~FORM_PLACES ();

		//! Create form with label from resource lookup.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,	// Parent pane
			VIEW *view							//!< Associated view
			);

		//! Set center point from view canvas coordinates.
		void SetCenterPoint (
			MGUI::POINT ptCanvas				//!< Point in view canvas
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//=====================================================================================================================

}	// End namespace UI
}	// End namespace GRE

#endif		//	INC_GRE_UIFORMPLACES_H
