/**
 * \file gre/uiregiongen.h
 * \brief GRE User Interface for region generation
 *
 * \if NODOC
 * $Id: uiregiongen.h_v 1.2 2014/05/13 21:32:03 mju Exp $
 *
 * $Log: uiregiongen.h_v $
 * Revision 1.2  2014/05/13 21:32:03  mju
 * Add dlgRegionGenerateFromLayer.
 *
 * Revision 1.1  2008/01/09 15:52:38  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_UIREGIONGEN_H
#define	INC_GRE_UIREGIONGEN_H

#ifndef	INC_MI32_RGNGEN_H
#include <mi32/rgngen.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
struct RGNELEMLIST;
class TRANS2D_MAPGEN;
namespace GRE {
	class LAYER;
	class VIEW;
	}
#endif // GENERATING_DOXYGEN_OUTPUT


namespace GRE {
namespace UI {

ERRVALUE DlgRegionGenerateFromLayer (
	MDLGPARENT dlgparent,									//!< Parent for dialog
	GRE::LAYER *layer,
	REGIONGENMETHOD RegionGenMethod,						//!< Region generation method
	RGNELEMLIST& ElemList
	);

//! Dialog allowing region creation from existing region instance.
ERRVALUE DlgRegionGenerateFromRegion (
	MDLGPARENT dlgparent,									//!< Parent for dialog
	REGIONGENMETHOD RegionGenMethod,						//!< Region generation method
	const REGION2D& SrcRegion,								//!< Source region
	GRE::VIEW *view,											//!< View for region preview
	const TRANS2D_MAPGEN& TransSrcToViewDevice		//!< Transformation from source region's CRS to view device
	);

} // End namespace UI
} // End namespace GRE

#endif	// INC_GRE_UIREGIONGEN_H
