/**
 * \file mgui/dlgcolorpalette.h
 *
 * \if NODOC
 * $Id: dlgcolorpalette.h_v 1.3 2016/01/19 18:25:06 mju Exp $
 *
 * $Log: dlgcolorpalette.h_v $
 * Revision 1.3  2016/01/19 18:25:06  mju
 * Allow to specify label for "none" option.
 *
 * Revision 1.2  2015/06/11 19:13:45  mju
 * Use colorpalettetype hdr.
 *
 * Revision 1.1  2014/12/04 21:43:59  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MGUI_DLGCOLORPALETTE_H
#define	INC_MGUI_DLGCOLORPALETTE_H

#ifndef	INC_MI32_COLORPALETTETYPE_H
#include <mi32/colorpalettetype.h>
#endif

class MISTRING;

namespace MGUI {

//! Dialog to prompt user to select color palette.
//! @return Selected COLORPALETTETYPE or error < 0.
int DlgGetColorPalette (
	MDLGPARENT dlgparent,					//!< Parent for dialog
	MISTRING &PaletteId,						//!< Palette ID passed/returned
	COLORPALETTETYPE AllowedTypes,		//!< Allowed palette types
	const MISTRING *pLabelNone = 0		//!< Label for "none" option, nullptr to not show
	);

}	// End namespace MGUI

#endif	// INC_MGUI_DLGCOLORPALETTE_H
