/**
 * \file mi32/orient8.h
 * \brief ORIENT8 definitions
 *
 * \if NODOC
 * $Id: orient8.h_v 1.1 2013/05/15 15:51:18 mju Exp $
 *
 * $Log: orient8.h_v $
 * Revision 1.1  2013/05/15 15:51:18  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_ORIENT8_H
#define	INC_MI32_ORIENT8_H

//! 8-way orientation enumeration.
enum ORIENT8 {
	ORIENT8_Unchanged =			0,		//!< Unchanged
	ORIENT8_Rotate180 =			1,		//!< Rotate 180 degrees
	ORIENT8_RotateCW =			2,		//!< Rotate clockwise 90 degrees
	ORIENT8_RotateCCW =			3,		//!< Rotate counterclockwise 90 degrees
	ORIENT8_MirrorHorizontal =	4,		//!< Mirror in horizontal direction
	ORIENT8_MirrorVertical =	5,		//!< Mirror in vertical direction
	ORIENT8_MirrorRotateCW =	6,		//!< Mirror horizontally then rotate 90 degrees clockwise
	ORIENT8_MirrorRotateCCW =	7,		//!< Mirror horizontally then rotate 90 degrees counterclockwise
	ORIENT8_MASK_Rotate90 =		2,		//!< 90 degree rotation used, allows simple check for swapping X/Y dimensions
	};

#endif	// INC_MI32_ORIENT8_H
