/**
 * \file rastdisp.h <mi32/rastdisp.h>
 * \brief RASTDISPMODE definitions
 *
 * \if NODOC
 * $Id: rastdisp.h_v 1.5 2015/05/27 20:18:16 mju Exp $
 *
 * $Log: rastdisp.h_v $
 * Revision 1.5  2015/05/27 20:18:16  mju
 * Remove hsv.
 *
 * Revision 1.4  2014/06/23 14:40:53  mju
 * Add rastedispmode_Invalid.
 *
 * Revision 1.3  2014/06/12 14:31:09  mju
 * Use enum instead of preproc.
 *
 * Revision 1.2  2003/09/15 13:49:56  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.1  1999/04/28 21:30:13  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_MI32_RASTDISP_H
#define	INC_MI32_RASTDISP_H

//! Raster "display" modes used by various library functions.
//! Values will not change and so may be stored in files.
enum RASTDISPMODE {
	RASTDISPMODE_Single =			0,		//!< Single raster
	RASTDISPMODE_Invalid =			1,
	RASTDISPMODE_MultiCI =			2,		//!< Color / Intensity
	RASTDISPMODE_MultiRGB =			3,		//!< Red / Green / Blue
	RASTDISPMODE_MultiHIS =			4,		//!< Hue / Intensity / Saturation
	RASTDISPMODE_MultiHBS =			5,		//!< Hye / Brightness / Saturation
	RASTDISPMODE_MultiRGBI =		6,		//!< Red / Green / Blue / Intensity
	RASTDISPMODE_MultiRGBB =		7,		//!< Red / Green / Blue / Brightness
	RASTDISPMODE_MultiCMY =			9,		//!< Cyan / Magenta / Yellow
	RASTDISPMODE_MultiCMYK =		10,	//!< Cyan / Magenta / Yellow / Black
	RASTDISPMODE_Hyperspectral =	11,	//!< Hyperspectral image
	};

#endif	// INC_MI32_RASTDISP_H
