/**
 * \file mi32/textformat.h
 * \brief TEXTFORMAT class definitions
 *
 * \if NODOC
 * $Id: textformat.h_v 1.1 2014/01/23 18:32:39 mju Exp $
 *
 * $Log: textformat.h_v $
 * Revision 1.1  2014/01/23 18:32:39  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_TEXTFORMAT_H
#define	INC_MI32_TEXTFORMAT_H

#ifndef	INC_MI32_MISTRING_H
#include <mi32/mistring.h>
#endif

//=====================================================================================================================

//! Text Format support for 2D line equation.
class TEXTFORMAT_LINE2D {
	public:

		enum EQUATIONFORM {
			EQUATIONFORM_L_eq_mR_pm_b =	0x01,	// [Left] = m * [Right] +- b
			EQUATIONFORM_L_eq_m_Rpmb =		0x02,	// [Left] = m * ([Right] +- b)
			EQUATIONFORM_X =					0x10,	// X = ...
			EQUATIONFORM_Y =					0x20,	// Y = ...
			EQUATIONFORM_X_eq_mY_pm_b =	EQUATIONFORM_X | EQUATIONFORM_L_eq_mR_pm_b,
			EQUATIONFORM_X_eq_m_Ypmb =		EQUATIONFORM_X | EQUATIONFORM_L_eq_m_Rpmb,
			EQUATIONFORM_Y_eq_mX_pm_b =	EQUATIONFORM_Y | EQUATIONFORM_L_eq_mR_pm_b,
			EQUATIONFORM_Y_eq_m_Xpmb =		EQUATIONFORM_Y | EQUATIONFORM_L_eq_m_Rpmb,
			};

		//! Get display string in specified form.
		static MISTRING GetDisplayString (
			EQUATIONFORM form,
			const MISTRING& VarNameR,
			double m,
			double b
			);

	};

//=====================================================================================================================

#endif	// INC_MI32_TEXTFORMAT_H
