/**
 * \file rvc/uidlgdbfieldcsvlist.h
 * \brief RVC::UI::DLG_DB_FIELD_CSVLIST definitions
 *
 * \if NODOC
 * $Id$
 *
 * $Log$
 * \endif
**/

#ifndef	INC_RVC_UIDLGDBFIELDCSVLIST_H
#define	INC_RVC_UIDLGDBFIELDCSVLIST_H

#ifndef	INC_RVC_UIDLGDBFIELDVALUE_H
#include <rvc/uidlgdbfieldvalue.h>
#endif

namespace RVC {
namespace UI {

//=====================================================================================================================

//! Dialog to pick values for CSV list field.
class DLG_DB_FIELD_CSVLIST : public DLG_DB_FIELD_VALUE {
	public:

		//! Constructor.
		DLG_DB_FIELD_CSVLIST ();

		//! Destructor.
		virtual ~DLG_DB_FIELD_CSVLIST ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		class SETTINGS : public DLG_DB_FIELD_VALUE::SETTINGS {
			public:
				SETTINGS ();
				const LPOINT2D& GetPosition () const
					{ return (m_Position); }
				bool HasPlacement () const
					{ return (m_Position.x >= 0 && m_Position.y >= 0); }
				void SetPosition (INT32 x, INT32 y)
					{ if (x != m_Position.x || y != m_Position.y) { SetChanged(); m_Position.x = x; m_Position.y = y; } }
			private:
				#ifndef GENERATING_DOXYGEN_OUTPUT
				typedef SETTINGS THISCLASS;
				LPOINT2D m_Position;

				virtual const char* v_GetObjNameBase () const;
				virtual const SERIALIZERITEM* v_SerialGetItemDef () const;
				#endif
			};

		class PRIV;

		SETTINGS m_Settings;
		PRIV *m_pPriv;

		// SHELL/DLGSHELL overrides.
		virtual ERRVALUE v_CreateContent ();

		// DLG_DB_FIELD_VALUE overrides.
		virtual ERRVALUE v_GetValue (RVC::DBTABLE::RECORD& record);
		virtual ERRVALUE v_Setup (const RVC::DBTABLE& ObjTable);
		virtual ERRVALUE v_SetValue (const RVC::DBTABLE::RECORD& record);
		virtual void v_UpdateSettings ();
		#endif
	};

//=====================================================================================================================

}	// End namespace UI
}	// End namespace RVC

#endif	// INC_RVC_UIDLGDBFIELDCSVLIST_H

