/**
 * \file rvc/uifiltergetobjectlegacy.h
 * \brief RVC::UI::FILTER_GETOBJECT_LEGACY definitions
 *
 * \if NODOC
 * $Id: uifiltergetobjectlegacy.h_v 1.2 2013/05/09 14:50:33 mju Exp $
 *
 * $Log: uifiltergetobjectlegacy.h_v $
 * Revision 1.2  2013/05/09 14:50:33  mju
 * Add getDlgStyleFromLegacy.
 *
 * Revision 1.1  2013/05/09 13:42:23  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_RVC_UIFILTERGETOBJECTLEGACY_H
#define	INC_RVC_UIFILTERGETOBJECTLEGACY_H

#ifndef	INC_MGUI_DLGGETOBJECTFILTER_H
#include <mgui/dlggetobjectfilter.h>
#endif

#ifndef	INC_MGUI_DLGGETOBJECTSTYLE_H
#include <mgui/dlggetobjectstyle.h>
#endif

#ifndef	INC_RVC_GETOBJFLAGS_H
#include <rvc/getobjflags.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
namespace RVC {
	class GETOBJFILTER;
	}
#endif

namespace RVC {
namespace UI {

//=====================================================================================================================

//! Wrapper around legacy RVC::GETOBJFILTER.
class FILTER_GETOBJECT_LEGACY : public MGUI::DLG_GETOBJECT_FILTER {
	public:

		static MGUI::DLG_GETOBJECT_STYLE GetDlgStyleFromLegacy (
			GETOBJFLAGS GetObjFlags
			);

		//! Constructor.
		FILTER_GETOBJECT_LEGACY (
			const RVC::OBJTYPESET ObjTypeSetSelectable,
			RVC::GETOBJFILTER *pFilterLegacy
			);

		FILTER_GETOBJECT_LEGACY (
			const RVC::OBJTYPESET ObjTypeSetSelectable,
			const RVC::OBJTYPESET ObjTypeSetValidParent,
			RVC::GETOBJFILTER *pFilterLegacy
			);

		~FILTER_GETOBJECT_LEGACY ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		RVC::GETOBJFILTER *m_pFilterLegacy;

		void SetValues () const;

		virtual bool v_IsFileSelectable (const FILEPATH& filepath, int position) const;
		virtual bool v_IsListValid (const RVC::OBJITEMLIST& objlist) const;
		virtual bool v_IsObjectBrowsable (const RVC::OBJITEM& objitem) const;
		virtual bool v_IsObjectSelectable (const RVC::OBJITEM& objitem, int position) const;
		virtual bool v_IsObjectValidParent (const RVC::OBJITEM& parent) const;
		#endif
	};

//=====================================================================================================================

}	// End namespace UI
}	// End namespace RVC

#endif	// INC_RVC_UIFILTERGETOBJECTLEGACY_H
